<?php

namespace Intergo\Wallet\ValueObjects;

class TransactionInfoVO
{
    private int $user_id;
    private float $amount = 0.0;
    private string $note = '';
    private ?string $reason = null;
    private string $remarks = '';
    private float $balance = 0.0;
    private float $new_balance = 0.0;
    private int $count_transactions = 0;

    /**
     * @param $amount
     * @param array $information
     */
    public function __construct($amount, array $information = [])
    {
        $this->setAmount($amount);
        $this->setNote($information['note'] ?? '');
        $this->setReason($information['reason'] ?? null);
        $this->setRemarks(json_encode($information));
    }

    /**
     * @return int
     */
    public function getUserId(): int
    {
        return $this->user_id;
    }

    /**
     * @param int $user_id
     */
    public function setUserId(int $user_id): void
    {
        $this->user_id = $user_id;
    }

    /**
     * @return int
     */
    public function getAmount(): int
    {
        return $this->amount;
    }

    /**
     * @param int $amount
     */
    public function setAmount(int $amount): void
    {
        $this->amount = $amount;
    }

    /**
     * @return string
     */
    public function getNote(): string
    {
        return $this->note;
    }

    /**
     * @param string $note
     */
    public function setNote(string $note): void
    {
        $this->note = $note;
    }

    /**
     * @return ?string
     */
    public function getReason(): ?string
    {
        return $this->reason;
    }

    /**
     * @param string $reason
     */
    public function setReason(string $reason): void
    {
        $this->reason = $reason;
    }

    /**
     * @return string
     */
    public function getRemarks(): string
    {
        return $this->remarks;
    }

    /**
     * @param string $remarks
     */
    public function setRemarks(string $remarks): void
    {
        $this->remarks = $remarks;
    }

    /**
     * @return float
     */
    public function getBalance(): float
    {
        return $this->balance;
    }

    /**
     * @param float $balance
     * @return float
     */
    public function setBalance(float $balance): float
    {
        return $this->balance = $balance;
    }

    /**
     * @return float
     */
    public function getNewBalance(): float
    {
        return $this->new_balance;
    }

    /**
     * @param float $new_balance
     * @return float
     */
    public function setNewBalance(float $new_balance): float
    {
        return $this->new_balance = $new_balance;
    }

    /**
     * @return int
     */
    public function getCountTransactions(): int
    {
        return $this->count_transactions;
    }

    /**
     * @param int $count_transactions
     */
    public function setCountTransactions(int $count_transactions): void
    {
        $this->count_transactions = $count_transactions;
    }
}
